/* Console */
/* The EDOS project */
/* Copyright (C)2000-2006 Berke Durak                               */
/* Released under the GNU Lesser General Public License version 2.1 */

var stdout;
var command_table;
var console_lines = 500;
var sid = "";
var manager1;
var req = new XMLHttpRequest();
var busy = false;
var busy_start_time = 0;
var busy_background_indicator_state = false;
const var busy_start_background_indicator_delay = 250;
const var tab_title_length_limit = 20;
var busy_flash_state = false;
var busy_previously = false;
var busy_flash_interval = 300;
var status_paragraph;
var memorize_limit = 500;
var processor_busy = false;

/*(*** find */
function find(name)
{
  return document.getElementById(name);
}
/****)*/
/*(*** get_time */
function get_time()
{
  var date = new Date();
  return date.getTime();
}
/****)*/
/*(*** limit */
function limit(m,u)
{
  if(u.length < m + 3) return u;
  else {
    return u.substring(0, m) + "...";
  }
}
/****)*/
/*(*** Tabbed_Manager */
function Tabbed_Manager(tabs,contents)
{
  this.tabs     = tabs;
  this.contents = contents;
  this.active   = null;
  this.max_tabs = 7;

  this.activate_by_thing = function(thing) {
    /* deactivate other tag */
    if(this.active != null) {
      this.active.tab.setAttribute("class", "tab");
      this.active.panel.setAttribute("class", "content");
    }
    thing.tab.setAttribute("class", "tab active");
    thing.panel.setAttribute("class", "content active");
    this.active = thing;
  };
  this.remove_by_thing = function(thing) {
    var mgr;
    var tab_other;

    mgr = thing.manager;

    tab_other = thing.tab.previousSibling;
    if(tab_other == null || tab_other.tabbed_manager_thing == null) {
      tab_other = thing.tab.nextSibling;
    }
    if(tab_other != null && tab_other.tabbed_manager_thing != null) {
      this.activate_by_thing(tab_other.tabbed_manager_thing);
    }
    mgr.tabs.removeChild(thing.tab);
    mgr.contents.removeChild(thing.panel);
  }
  this.toggle_pinned = function(e) {
    var thing = this.tabbed_manager_thing;

    if(thing.is_pinned) {
      this.setAttribute("class", "button pin");
      thing.is_pinned = false;
    } else {
      this.setAttribute("class", "button pinned");
      thing.is_pinned = true;
    }
    e.preventDefault();
    return false;
  }
  this.remove = function() {
    this.tabbed_manager_thing.manager.remove_by_thing(this.tabbed_manager_thing);
    return false;
  }
  this.activate = function(e) {
    this.tabbed_manager_thing.manager.activate_by_thing(this.tabbed_manager_thing);
    e.preventDefault();
    return false;
  }
  this.remove_first_pinned_tab = function() {
    var num_tabs;
    var tabs;
    var thing;

    tabs = this.tabs.childNodes;
    num_tabs = tabs.length;
    for(var i = 0; i < num_tabs; i++) {
      thing = tabs[i].tabbed_manager_thing;
      if(thing != null) {
        if(thing.is_pinned == false) {
          this.remove_by_thing(thing);
          return true;
        }
      }
    }

    return false;
  }
  this.add_tab = function(name, content) {
    var num_tabs;
    var thing;

    num_tabs = tabs.childNodes.length;

    if(num_tabs >= this.max_tabs) {
      if(!this.remove_first_pinned_tab()) {
        stdout.print("Tab manager: Too many pinned tabs, refusing display.");
        return;
      }
    }

    /* create a new thing */
    thing = new Object();
    thing.manager = this;

    /* create tab header */
    var tab_top = document.createElement("A");
    tab_top.tabbed_manager_thing = thing;

    var tab = document.createElement("DIV");
    tab_top.appendChild(tab);

    var t = document.createElement("SPAN");
    t.textContent = name;
    t.setAttribute("class", "title");
    tab.appendChild(t);

    t = document.createElement("INPUT");
    t.setAttribute("class", "button pin");
    t.setAttribute("type", "submit");
    t.setAttribute("name", "noname");
    t.setAttribute("value", "P");
    t.tabbed_manager_thing = thing;
    t.addEventListener("click", this.toggle_pinned, false);
    thing.pin_button = t;
    tab.appendChild(t);
    thing.is_pinned = false;

    t = document.createElement("INPUT");
    t.setAttribute("class", "button close");
    t.setAttribute("type", "submit");
    t.setAttribute("name", "noname");
    t.setAttribute("value", "X");
    t.tabbed_manager_thing = thing;
    t.addEventListener("click", this.remove, false);
    tab.appendChild(t);

    tab.tabbed_manager_thing = thing;
    tab.addEventListener("click", this.activate, false); // Doesn't work, why !? BECAUSE it is a frigging string
    thing.tab = tab_top;

    /* create a tab panel */
    var panel = document.createElement("DIV");
    panel.setAttribute("class", "content");
    panel.appendChild(content);
    thing.panel = panel;

    /* activate current one */
    this.activate_by_thing(thing);

    /* add the tab */
    this.tabs.appendChild(tab_top);
    this.contents.appendChild(panel);
  };
}
/***)*/
/*(*** Ring */
function Ring__add(thing)
{
  if(this.length < this.size) {
    this.contents[this.length ++] = thing;
    this.father.adder(thing);
  } else {
    this.father.remover(this.contents[this.index]);
    this.father.adder(thing);
    this.contents[this.index] = thing;
    this.index ++;
    if(this.index == this.length) this.index = 0;
  }
}

function Ring__get(index)
{
  var i;
  
  i = this.index - index - 1;
  if(i < 0) i += this.length;
  return this.contents[i];
}

function Ring(size,father)
{
  this.size = size;
  this.contents = Array(size);
  this.index = 0;
  this.length = 0;
  this.add = Ring__add;
  this.get = Ring__get;
  this.father = father;
}
/****)*/
/*(*** Message_Area */
function Message_Area__adder(thing)
{
  this.div.appendChild(thing);
}

function Message_Area__remover(thing)
{
  this.div.removeChild(thing);
}

function Message_Area__add(thing)
{
  this.ring.add(thing);
}

function Message_Area__print(msg)
{
  var p;
  var lines;

  lines = msg.split(/\n/);
  for(var i = 0; i < lines.length; i ++) {
    var msg = lines[i];
    p = document.createElement("PRE");
    p.textContent = msg;
    this.ring.add(p);
  }
}

function Message_Area__clear()
{
  for(var i = 0; i < this.ring.size; i ++) {
    this.print("  ");
  }
}

function Message_Area(name, number_of_lines)
{
  this.div = find(name);
  this.ring = new Ring(number_of_lines, this);
  this.adder = Message_Area__adder;
  this.remover = Message_Area__remover;
  this.clear = Message_Area__clear;
  this.print = Message_Area__print;
  this.add = Message_Area__add;
}
/****)*/
/*(*** CLI */
var cli_command;
var cli_prompt;

const var KEYCODE_CURSORUP = 38;
const var KEYCODE_CURSORDOWN = 40;
var cli_history_lines = 200;
var cli_history;
var cli_history_peek;
var cli_history_peeking = false;

function CLI__history_add(cmd)
{
  if(cmd != "") {
    cli_history.add(cmd);
    return true;
  } else return false;
}
function CLI__history_delta(delta)
{
  cli_history_peek += delta;
  if(cli_history_peek < 0) cli_history_peek = 0;
  if(cli_history_peek >= cli_history.length) cli_history_peek = cli_history.length - 1;
}
function CLI__history_recall(delta)
{
  if(!cli_history_peeking) {
    var h;
    if(delta < 0 || !cli_history.length) return;
    cli_history_peeking = true;
    h = cli_history.get(cli_history_peek);
    if(CLI__history_add(cli_command.value)) {
      cli_history_peek ++;
    } else {

    }
    cli_command.value = h;
  } else {
    CLI__history_delta(delta);
    cli_command.value = cli_history.get(cli_history_peek);
  }
}

function CLI__listener(e)
{
  var key = e.keyCode;

  if(processor_busy) {
    e.preventDefault();
    return;
  }

  switch(key) {
    case KEYCODE_CURSORUP:
      CLI__history_recall(1);
      break;
    case KEYCODE_CURSORDOWN:
      CLI__history_recall(-1);
      break;
    default:
      break;
  }
}

function CLI__init()
{
  var father;

  cli_command = find("command");
  cli_prompt = find("prompt");
  cli_command.addEventListener("keypress", CLI__listener, false);
  father = new Object();
  father.adder   = function() { };
  father.remover = function() { };
  cli_history = new Ring(cli_history_lines, father);
  cli_history_peek = 0;
}

function CLI__focus()
{
  cli_command.focus();
  cli_command.scrollIntoView();
}

function CLI__submitted()
{
  var cmd;

  if(processor_busy) return false;
  processor_busy = true;
  cmd = cli_command.value;
  stdout.print("> " + cmd);
  cli_command.value = "";
  CLI__history_add(cmd);
  cli_history_peek = 0;
  cli_history_peeking = false;
  Processor__transmit_command(cmd);
  return false;
}
/****)*/
/*(*** Dir_Display */
function Dir_Display(xml)
{
  var entries = new Array();
  var dir = xml.getElementsByTagName("entry");

  for(var i = 0; i < dir.length; i ++) {
    var entry = dir[i].attributes.getNamedItem("path").nodeValue;
    entries[i] = entry;
  }

  this.entries = entries;
  this.display_length = 18;
  this.display_start = 0;
  this.element = document.createElement("DIV");
  this.element.dir_display = this;

  this.prev = function() {
    this.display_start -= this.display_length;
    if(this.display_start <= 0) {
      this.display_start = 0;
    }
    this.refresh();
  }

  this.next = function() {
    if(this.display_start + this.display_length < this.entries.length) {
      this.display_start += this.display_length;
    }
    this.refresh();
  }

  /* Navigation */
  var n_back = document.createElement("SPAN");
  n_back.textContent = "<<<< ";
  n_back.onclick = function() {
    this.parentNode.dir_display.prev();
    return false;
  }
  this.element.appendChild(n_back);

  this.position = document.createTextNode("");
  this.element.appendChild(this.position);
  
  var n_fwd = document.createElement("SPAN");
  n_fwd.textContent = " >>>>";
  n_fwd.onclick = function(event) {
    stdout.print("click " + event);
    this.parentNode.dir_display.next();
    return false;
  }
  this.element.appendChild(n_fwd);

  this.refresh = function() {
    var list = document.createElement("UL");
    var i0, i1;

    i0 = this.display_start;
    i1 = this.display_start + this.display_length - 1;
    if(i1 >= this.entries.length) i1 = this.entries.length - 1;

    for(var i = i0; i <= i1; i++) {
      var entry = document.createElement("LI");
      entry.textContent = this.entries[i];
      entry.onclick = function() {
        stdout.print("Showing " + this.textContent);
        cmd_ls(Array("ls",this.textContent));
      };
      list.appendChild(entry);
    }

    if(this.list != null) this.element.removeChild(this.list);
    this.element.appendChild(list);
    this.list = list;

    var msg = "Showing " + this.display_start + " to " + (this.display_start + this.display_length - 1) + " out of " + this.entries.length;
    this.position.textContent = msg;
  };

  this.refresh();
}
/****)*/
/*(*** create_multiline_text */
function create_multiline_text(txt)
{
  /*var lines = txt.split(/\n/);
  var paragraph = document.createElement("P");
  for(var i = 0; i < lines.length; i ++) {
    var msg = lines[i];
    p = document.createElement("PRE");
    p.textContent = msg;
    paragraph.appendChild(p);
  }
  return paragraph;*/
  var p = document.createElement("PRE");
  p.textContent = txt;
  return p;
}
/****)*/
/*(*** Processor__transmit_command */
function Processor__transmit_command(dql)
{
  var dst = "/dql";
  Busy_change(true);

  req.open("GET", dst + "?sid=" + sid + "&q=" + encodeURIComponent(dql), true);
  req.overrideMimeType("text/xml");
  req.onreadystatechange = function() {
    if(req.readyState == 4) {
      try {
        if(req.status == 200) {
          var dir;
          var xml;
          xml = req.responseXML;
          if(xml == null) {
            stdout.print("Null XML, text response is " + req.responseText + ".");
          } else {
            var outputs = xml.getElementsByTagName("output");
            if(outputs.length == 0) {
              stdout.print("Invalid server response.");
            } else {
              var nodes = outputs[0].childNodes;
              var result = "";
              
              if(nodes.length > 0) {
                for(var i = 0; i < nodes.length; i ++) {
                  result += nodes[i].nodeValue;
                }
                if(result.length < memorize_limit) {
                  stdout.print(result);
                } else {
                  stdout.print("(Long result of " + result.length + " bytes sent to tab)");
                  manager1.add_tab(limit(tab_title_length_limit, dql), create_multiline_text(result));
                }
              }
            }
          }
        } else {
          stdout.print("Request failed with code " + req.status + ".");
        }
      } catch(x) {
        stdout.print("Got Javascript exception: " + x + ".");
      }
      processor_busy = false;
      Busy_change(false);
    }
  };
  req.send(null);
}
/****)*/
/*(*** Busy_flasher */
function Busy_flasher()
{ 
  var t = get_time();
  var time_ok = (t - busy_start_time) > busy_start_background_indicator_delay;

  if((busy && time_ok) || busy_flash_state) {
    busy_flash_state = !busy_flash_state;
    if(busy_flash_state) {
      status_paragraph.textContent = "COMPUTING";
    } else {
      status_paragraph.textContent = "";
    }
  }

  if((time_ok || !busy) && busy != busy_background_indicator_state) {
    if(busy) {
      cli_prompt.setAttribute("class", "busy");
    } else {
      cli_prompt.setAttribute("class", "");
    }
    busy_background_indicator_state = busy;
  }
}
/****)*/
/*(*** Busy_change */
function Busy_change(q)
{
  busy = q;
  busy_start_time = get_time();
}
/****)*/
/*(*** start */
function start()
{
  stdout = new Message_Area("messages", console_lines);
  stdout.clear();
  stdout.print("Welcome to the EDOS DQL Console.\nType #help for help.");
  manager1 = new Tabbed_Manager(find("tabs"), find("contents"));
  var console = find("console");
  sid = console.getAttribute("sid");
  status_paragraph = find("indicator");
  setInterval(Busy_flasher, busy_flash_interval);
  CLI__init();
  CLI__focus();
}
/****)*/
