(* Diagnosis *)
(* Copyright 2005-2007 Berke DURAK, INRIA Rocquencourt and The EDOS Project. *)
(* Released under the GNU LGPL version 2. *)

open Napkin
open Rapids

type ('package_id, 'versioned) reason =
| Not_available of 'package_id
| Requested of 'package_id
| Dependency of 'package_id * 'package_id list
| Empty_disjunction of 'package_id * 'versioned list
| Conflict of 'package_id * 'package_id

type ('not_installable_id, 'package_id, 'versioned) diagnosis = {
  dg_closure_size : int;
  dg_conflicts    : int;
  dg_disjunctions : int;
  dg_dependencies : int;
  dg_failures     : ('not_installable_id * ('package_id, 'versioned) reason list) array
}

val empty_diagnosis : ('a, 'b, 'c) diagnosis;;

val io_reason : 'a Io.literate -> 'b Io.literate -> ('a, 'b) reason Io.literate
val io_diagnosis : 'a Io.literate -> 'b Io.literate -> 'c Io.literate -> ('a, 'b, 'c) diagnosis Io.literate
